Index: pacemaker/pengine/test10/rsc-sets-clone-1.exp
===================================================================
--- pacemaker.orig/pengine/test10/rsc-sets-clone-1.exp
+++ pacemaker/pengine/test10/rsc-sets-clone-1.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="vm1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vm1" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm1"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="12" operation="monitor" operation_key="vm2_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vm2" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm2"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm2"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -21,7 +21,7 @@
     <action_set>
       <rsc_op id="13" operation="monitor" operation_key="vm3_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vm3" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm3"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm3"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -30,7 +30,7 @@
     <action_set>
       <rsc_op id="14" operation="monitor" operation_key="vm4_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vm4" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm4"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  xmfile="/etc/xen/vm/vm4"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -39,7 +39,7 @@
     <action_set>
       <rsc_op id="28" operation="stop" operation_key="stonithsys3_stop_0" on_node="sys2" on_node_uuid="sys2">
         <primitive id="stonithsys3" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
+        <attributes CRM_meta_on_node="sys2" CRM_meta_on_node_uuid="sys2" CRM_meta_timeout="20000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -52,7 +52,7 @@
     <action_set>
       <rsc_op id="15" operation="monitor" operation_key="stonithsys3_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="stonithsys3" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="15000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="15000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -61,7 +61,7 @@
     <action_set>
       <rsc_op id="10" operation="start" operation_key="stonithsys3_start_0" on_node="sys2" on_node_uuid="sys2">
         <primitive id="stonithsys3" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
+        <attributes CRM_meta_on_node="sys2" CRM_meta_on_node_uuid="sys2" CRM_meta_timeout="20000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -77,7 +77,7 @@
     <action_set>
       <rsc_op id="2" operation="monitor" operation_key="stonithsys3_monitor_15000" on_node="sys2" on_node_uuid="sys2">
         <primitive id="stonithsys3" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_interval="15000" CRM_meta_name="monitor" CRM_meta_start_delay="15000" CRM_meta_timeout="15000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
+        <attributes CRM_meta_interval="15000" CRM_meta_name="monitor" CRM_meta_on_node="sys2" CRM_meta_on_node_uuid="sys2" CRM_meta_start_delay="15000" CRM_meta_timeout="15000"  hostname="sys3" interface="lan" ipaddr="192.168.1.222" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -138,7 +138,7 @@
     <action_set>
       <rsc_op id="50" operation="monitor" operation_key="controld:1_monitor_10000" on_node="sys3" on_node_uuid="sys3">
         <primitive id="controld" long-id="controld:1" class="ocf" provider="pacemaker" type="controld"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_start_delay="0" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_start_delay="0" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -151,7 +151,7 @@
     <action_set>
       <rsc_op id="49" operation="start" operation_key="controld:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="controld" long-id="controld:1" class="ocf" provider="pacemaker" type="controld"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -164,7 +164,7 @@
     <action_set>
       <rsc_op id="16" operation="monitor" operation_key="controld:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="controld" long-id="controld:1" class="ocf" provider="pacemaker" type="controld"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -173,7 +173,7 @@
     <action_set>
       <rsc_op id="51" operation="start" operation_key="clvmd:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="clvmd" long-id="clvmd:1" class="ocf" provider="lvm2" type="clvmd"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  daemon_timeout="30"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  daemon_timeout="30"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -189,7 +189,7 @@
     <action_set>
       <rsc_op id="17" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="clvmd" long-id="clvmd:1" class="ocf" provider="lvm2" type="clvmd"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  daemon_timeout="30"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  daemon_timeout="30"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -198,7 +198,7 @@
     <action_set>
       <rsc_op id="52" operation="start" operation_key="o2cb:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="o2cb" long-id="o2cb:1" class="ocf" provider="ocfs2" type="o2cb"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -214,7 +214,7 @@
     <action_set>
       <rsc_op id="18" operation="monitor" operation_key="o2cb:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="o2cb" long-id="o2cb:1" class="ocf" provider="ocfs2" type="o2cb"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -223,7 +223,7 @@
     <action_set>
       <rsc_op id="54" operation="monitor" operation_key="iscsi1:1_monitor_120000" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi1" long-id="iscsi1:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -236,7 +236,7 @@
     <action_set>
       <rsc_op id="53" operation="start" operation_key="iscsi1:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi1" long-id="iscsi1:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -252,7 +252,7 @@
     <action_set>
       <rsc_op id="19" operation="monitor" operation_key="iscsi1:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi1" long-id="iscsi1:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -261,7 +261,7 @@
     <action_set>
       <rsc_op id="56" operation="monitor" operation_key="iscsi2:1_monitor_120000" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi2" long-id="iscsi2:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -274,7 +274,7 @@
     <action_set>
       <rsc_op id="55" operation="start" operation_key="iscsi2:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi2" long-id="iscsi2:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -290,7 +290,7 @@
     <action_set>
       <rsc_op id="20" operation="monitor" operation_key="iscsi2:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="iscsi2" long-id="iscsi2:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="30000"  portal="192.168.2.2" target="iqn.2010-03.com.example:tar2"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -299,7 +299,7 @@
     <action_set>
       <rsc_op id="57" operation="start" operation_key="vg1:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vg1" long-id="vg1:1" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  volgrpname="vg1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  volgrpname="vg1"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -315,7 +315,7 @@
     <action_set>
       <rsc_op id="21" operation="monitor" operation_key="vg1:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vg1" long-id="vg1:1" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  volgrpname="vg1"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  volgrpname="vg1"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -324,7 +324,7 @@
     <action_set>
       <rsc_op id="58" operation="start" operation_key="vg2:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vg2" long-id="vg2:1" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  volgrpname="vg2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  volgrpname="vg2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -340,7 +340,7 @@
     <action_set>
       <rsc_op id="22" operation="monitor" operation_key="vg2:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="vg2" long-id="vg2:1" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  volgrpname="vg2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000"  volgrpname="vg2"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -349,7 +349,7 @@
     <action_set>
       <rsc_op id="60" operation="monitor" operation_key="fs2:1_monitor_20000" on_node="sys3" on_node_uuid="sys3">
         <primitive id="fs2" long-id="fs2:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="40000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="40000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -362,7 +362,7 @@
     <action_set>
       <rsc_op id="59" operation="start" operation_key="fs2:1_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="fs2" long-id="fs2:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -378,7 +378,7 @@
     <action_set>
       <rsc_op id="23" operation="monitor" operation_key="fs2:1_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="fs2" long-id="fs2:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  device="/dev/vg2/lv1" directory="/mnt" fstype="ocfs2"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -435,7 +435,7 @@
     <action_set>
       <rsc_op id="24" operation="monitor" operation_key="nfs1:0_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="nfs1" long-id="nfs1:0" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  device="192.168.2.2:/fs1" directory="/mnt" fstype="nfs"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="40000"  device="192.168.2.2:/fs1" directory="/mnt" fstype="nfs"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -444,7 +444,7 @@
     <action_set>
       <rsc_op id="74" operation="monitor" operation_key="stonithsys2_monitor_15000" on_node="sys3" on_node_uuid="sys3">
         <primitive id="stonithsys2" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_interval="15000" CRM_meta_name="monitor" CRM_meta_start_delay="15000" CRM_meta_timeout="15000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
+        <attributes CRM_meta_interval="15000" CRM_meta_name="monitor" CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_start_delay="15000" CRM_meta_timeout="15000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -457,7 +457,7 @@
     <action_set>
       <rsc_op id="73" operation="start" operation_key="stonithsys2_start_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="stonithsys2" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_timeout="20000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -470,7 +470,7 @@
     <action_set>
       <rsc_op id="25" operation="monitor" operation_key="stonithsys2_monitor_0" on_node="sys3" on_node_uuid="sys3">
         <primitive id="stonithsys2" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="15000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
+        <attributes CRM_meta_on_node="sys3" CRM_meta_on_node_uuid="sys3" CRM_meta_op_target_rc="7" CRM_meta_timeout="15000"  hostname="sys2" interface="lan" ipaddr="192.168.1.221" passwd="****" userid="admin"/>
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/rsc-sets-clone.exp
===================================================================
--- pacemaker.orig/pengine/test10/rsc-sets-clone.exp
+++ pacemaker/pengine/test10/rsc-sets-clone.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="3" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -25,7 +25,7 @@
     <action_set>
       <rsc_op id="7" operation="start" operation_key="rsc3_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="6" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -47,7 +47,7 @@
     <action_set>
       <rsc_op id="8" operation="stop" operation_key="rsc:0_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc" long-id="rsc:0" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/rsc-sets-master.exp
===================================================================
--- pacemaker.orig/pengine/test10/rsc-sets-master.exp
+++ pacemaker/pengine/test10/rsc-sets-master.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="3" operation="stop" operation_key="rsc:0_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc" long-id="rsc:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="2" operation="demote" operation_key="rsc:0_demote_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc" long-id="rsc:0" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -32,7 +32,7 @@
     <action_set>
       <rsc_op id="6" operation="promote" operation_key="rsc:1_promote_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc" long-id="rsc:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -132,7 +132,7 @@
     <action_set>
       <rsc_op id="16" operation="start" operation_key="rsc1_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -148,7 +148,7 @@
     <action_set>
       <rsc_op id="15" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -157,7 +157,7 @@
     <action_set>
       <rsc_op id="18" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -173,7 +173,7 @@
     <action_set>
       <rsc_op id="17" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -182,7 +182,7 @@
     <action_set>
       <rsc_op id="20" operation="start" operation_key="rsc3_start_0" on_node="node2" on_node_uuid="node2">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="node2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -198,7 +198,7 @@
     <action_set>
       <rsc_op id="19" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="node1">
         <primitive id="rsc3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="node1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
